xref: /titanic_51/usr/src/cmd/svc/milestone/net-physical (revision 2b24ab6b3865caeede9eeb9db6b83e1d89dcd1ea)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
66927f468Sdp# Common Development and Distribution License (the "License").
76927f468Sdp# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
23e11c3f44Smeem# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
247c478bd9Sstevel@tonic-gate# Use is subject to license terms.
257c478bd9Sstevel@tonic-gate#
267c478bd9Sstevel@tonic-gate# Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T.
277c478bd9Sstevel@tonic-gate# All rights reserved.
287c478bd9Sstevel@tonic-gate#
297c478bd9Sstevel@tonic-gate
306927f468Sdp. /lib/svc/share/smf_include.sh
316927f468Sdp. /lib/svc/share/net_include.sh
326927f468Sdp
337c478bd9Sstevel@tonic-gate#
34f4b3ec61Sdh155122# In a shared-IP zone we need this service to be up, but all of the work
357c478bd9Sstevel@tonic-gate# it tries to do is irrelevant (and will actually lead to the service
367c478bd9Sstevel@tonic-gate# failing if we try to do it), so just bail out.
37f4b3ec61Sdh155122# In the global zone and exclusive-IP zones we proceed.
387c478bd9Sstevel@tonic-gate#
39f4b3ec61Sdh155122smf_configure_ip || exit $SMF_EXIT_OK
407c478bd9Sstevel@tonic-gate
417c478bd9Sstevel@tonic-gate# Make sure that the libraries essential to this stage of booting can be found.
427c478bd9Sstevel@tonic-gateLD_LIBRARY_PATH=/lib; export LD_LIBRARY_PATH
437c478bd9Sstevel@tonic-gate
447c478bd9Sstevel@tonic-gatesmf_netstrategy
457c478bd9Sstevel@tonic-gate
46f4b3ec61Sdh155122if smf_is_globalzone; then
47d62bc4baSyz147064	net_reconfigure || exit $SMF_EXIT_ERR_CONFIG
48d62bc4baSyz147064
494eaa4710SRishi Srivatsavai	# Update PVID on interfaces configured with VLAN 1
504eaa4710SRishi Srivatsavai	update_pvid
514eaa4710SRishi Srivatsavai
52d62bc4baSyz147064	#
53d62bc4baSyz147064	# Upgrade handling. The upgrade file consists of a series of dladm(1M)
54d62bc4baSyz147064	# commands. Note that after we are done, we cannot rename the upgrade
55d62bc4baSyz147064	# script file as the file system is still read-only at this point.
56d62bc4baSyz147064	# Defer this to the manifest-import service.
57d62bc4baSyz147064	#
58d62bc4baSyz147064	upgrade_script=/var/svc/profile/upgrade_datalink
59d62bc4baSyz147064	if [ -f "${upgrade_script}" ]; then
60d62bc4baSyz147064		. "${upgrade_script}"
61d62bc4baSyz147064	fi
62d62bc4baSyz147064
637c478bd9Sstevel@tonic-gate	#
64b509e89bSRishi Srivatsavai	# Bring up simnets, link aggregations and initialize security objects.
650ba2cbe9Sxc151355	# Note that link property initialization is deferred until after
660ba2cbe9Sxc151355	# IP interfaces are plumbed to ensure that the links will not
67b509e89bSRishi Srivatsavai	# be unloaded (and the property settings lost). We should bring
68b509e89bSRishi Srivatsavai	# up simnets prior to VLANs/Aggrs to enable creation of VLANs/Aggrs
69b509e89bSRishi Srivatsavai	# over simnets.
70210db224Sericheng	#
71b509e89bSRishi Srivatsavai	/sbin/dladm up-simnet
72210db224Sericheng	/sbin/dladm up-aggr
73d62bc4baSyz147064	/sbin/dladm up-vlan
740ba2cbe9Sxc151355	/sbin/dladm init-secobj
75da14cebeSEric Cheng	#
76da14cebeSEric Cheng	# Bring up VNICs
77da14cebeSEric Cheng	#
78da14cebeSEric Cheng	/sbin/dladm up-vnic
79da14cebeSEric Cheng	#
80da14cebeSEric Cheng	# Create flows via flowadm.
81da14cebeSEric Cheng	#
82da14cebeSEric Cheng	/sbin/flowadm init-flow
83f4b3ec61Sdh155122fi
84210db224Sericheng
85210db224Sericheng#
867c478bd9Sstevel@tonic-gate# If the system was net booted by DHCP, hand DHCP management off to the
877c478bd9Sstevel@tonic-gate# DHCP agent (ifconfig communicates to the DHCP agent through the
887c478bd9Sstevel@tonic-gate# loopback interface).
897c478bd9Sstevel@tonic-gate#
907c478bd9Sstevel@tonic-gateif [ -n "$_INIT_NET_IF" -a "$_INIT_NET_STRATEGY" = "dhcp" ]; then
917c478bd9Sstevel@tonic-gate	/sbin/dhcpagent -a
927c478bd9Sstevel@tonic-gatefi
937c478bd9Sstevel@tonic-gate
947c478bd9Sstevel@tonic-gate#
957c478bd9Sstevel@tonic-gate# The network initialization is done early to support diskless and
967c478bd9Sstevel@tonic-gate# dataless configurations.  For IPv4 interfaces that were configured by
977c478bd9Sstevel@tonic-gate# the kernel (e.g.  those on diskless machines) and not configured by
987c478bd9Sstevel@tonic-gate# DHCP, reset the netmask using the local "/etc/netmasks" file if one
997c478bd9Sstevel@tonic-gate# exists, and then reset the broadcast address based on the netmask.
1007c478bd9Sstevel@tonic-gate#
1017c478bd9Sstevel@tonic-gate/sbin/ifconfig -auD4 netmask + broadcast +
1027c478bd9Sstevel@tonic-gate
103*2b24ab6bSSebastien Royis_iptun ()
104*2b24ab6bSSebastien Roy{
105*2b24ab6bSSebastien Roy	intf=$1
106*2b24ab6bSSebastien Roy	# Is this a persistent IP tunnel link?
107*2b24ab6bSSebastien Roy	/sbin/dladm show-iptun -P $intf > /dev/null 2>&1
108*2b24ab6bSSebastien Roy	if [ $? -eq 0 ]; then
109*2b24ab6bSSebastien Roy		return 0
110*2b24ab6bSSebastien Roy	fi
111*2b24ab6bSSebastien Roy	# Is this an implicit IP tunnel (i.e., ip.tun0)
112*2b24ab6bSSebastien Roy	ORIGIFS="$IFS"
113*2b24ab6bSSebastien Roy	IFS="$IFS."
114*2b24ab6bSSebastien Roy	set -- $intf
115*2b24ab6bSSebastien Roy	IFS="$ORIGIFS"
116*2b24ab6bSSebastien Roy	if [ $# -eq 2 -a \( "$1" = "ip" -o "$1" = "ip6" \) ]; then
117*2b24ab6bSSebastien Roy		#
118*2b24ab6bSSebastien Roy		# It looks like one, but another type of link might be
119*2b24ab6bSSebastien Roy		# using a name that looks like an implicit IP tunnel.
120*2b24ab6bSSebastien Roy		# If dladm show-link -P finds it, then it's not an IP
121*2b24ab6bSSebastien Roy		# tunnel.
122*2b24ab6bSSebastien Roy		#
123*2b24ab6bSSebastien Roy		/sbin/dladm show-link -Pp $intf > /dev/null 2>&1
124*2b24ab6bSSebastien Roy		if [ $? -eq 0 ]; then
125*2b24ab6bSSebastien Roy			return 1
126*2b24ab6bSSebastien Roy		else
127*2b24ab6bSSebastien Roy			return 0
128*2b24ab6bSSebastien Roy		fi
129*2b24ab6bSSebastien Roy	fi
130*2b24ab6bSSebastien Roy	return 1
131*2b24ab6bSSebastien Roy}
132*2b24ab6bSSebastien Roy
1337c478bd9Sstevel@tonic-gate#
1347c478bd9Sstevel@tonic-gate# All the IPv4 and IPv6 interfaces are plumbed before doing any
1357c478bd9Sstevel@tonic-gate# interface configuration.  This prevents errors from plumb failures
1367c478bd9Sstevel@tonic-gate# getting mixed in with the configured interface lists that the script
1377c478bd9Sstevel@tonic-gate# outputs.
1387c478bd9Sstevel@tonic-gate#
1397c478bd9Sstevel@tonic-gate
1407c478bd9Sstevel@tonic-gate#
1417c478bd9Sstevel@tonic-gate# Get the list of IPv4 interfaces to configure by breaking
1427c478bd9Sstevel@tonic-gate# /etc/hostname.* into separate args by using "." as a shell separator
1437c478bd9Sstevel@tonic-gate# character.
1447c478bd9Sstevel@tonic-gate#
1457c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname.*[0-9] 2>/dev/null`"
1467c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname.*[0-9]" ]; then
1477c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1487c478bd9Sstevel@tonic-gate	IFS="$IFS."
1497c478bd9Sstevel@tonic-gate	set -- $interface_names
1507c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1517c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1527c478bd9Sstevel@tonic-gate		shift
153e11c3f44Smeem		intf_name=$1
154e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname" ]; do
155e11c3f44Smeem			intf_name="$intf_name.$2"
1567c478bd9Sstevel@tonic-gate			shift
1577c478bd9Sstevel@tonic-gate		done
1587c478bd9Sstevel@tonic-gate		shift
159e11c3f44Smeem
160*2b24ab6bSSebastien Roy		# skip IP tunnel interfaces plumbed by net-iptun.
161*2b24ab6bSSebastien Roy		if is_iptun $intf_name; then
162*2b24ab6bSSebastien Roy			continue
163*2b24ab6bSSebastien Roy		fi
164*2b24ab6bSSebastien Roy
165e11c3f44Smeem	        read one rest < /etc/hostname.$intf_name
166e11c3f44Smeem		if [ "$one" = ipmp ]; then
167e11c3f44Smeem			ipmp_list="$ipmp_list $intf_name"
168e11c3f44Smeem		else
169e11c3f44Smeem			inet_list="$inet_list $intf_name"
1707c478bd9Sstevel@tonic-gate		fi
1717c478bd9Sstevel@tonic-gate	done
1727c478bd9Sstevel@tonic-gatefi
1737c478bd9Sstevel@tonic-gate
1747c478bd9Sstevel@tonic-gate#
1757c478bd9Sstevel@tonic-gate# Get the list of IPv6 interfaces to configure by breaking
1767c478bd9Sstevel@tonic-gate# /etc/hostname6.* into separate args by using "." as a shell separator
1777c478bd9Sstevel@tonic-gate# character.
1787c478bd9Sstevel@tonic-gate#
1797c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname6.*[0-9] 2>/dev/null`"
1807c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname6.*[0-9]" ]; then
1817c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1827c478bd9Sstevel@tonic-gate	IFS="$IFS."
1837c478bd9Sstevel@tonic-gate	set -- $interface_names
1847c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1857c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1867c478bd9Sstevel@tonic-gate		shift
187e11c3f44Smeem		intf_name=$1
188e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname6" ]; do
189e11c3f44Smeem			intf_name="$intf_name.$2"
1907c478bd9Sstevel@tonic-gate			shift
1917c478bd9Sstevel@tonic-gate		done
1927c478bd9Sstevel@tonic-gate		shift
193e11c3f44Smeem
194*2b24ab6bSSebastien Roy		# skip IP tunnel interfaces plumbed by net-iptun.
195*2b24ab6bSSebastien Roy		if is_iptun $intf_name; then
196*2b24ab6bSSebastien Roy			continue
197*2b24ab6bSSebastien Roy		fi
198*2b24ab6bSSebastien Roy
199e11c3f44Smeem	        read one rest < /etc/hostname6.$intf_name
200e11c3f44Smeem		if [ "$one" = ipmp ]; then
201e11c3f44Smeem			ipmp6_list="$ipmp6_list $intf_name"
202e11c3f44Smeem		else
203e11c3f44Smeem			inet6_list="$inet6_list $intf_name"
2047c478bd9Sstevel@tonic-gate		fi
2057c478bd9Sstevel@tonic-gate	done
2067c478bd9Sstevel@tonic-gatefi
2077c478bd9Sstevel@tonic-gate
208e11c3f44Smeem#
209e11c3f44Smeem# Create all of the IPv4 IPMP interfaces.
210e11c3f44Smeem#
211e11c3f44Smeemif [ -n "$ipmp_list" ]; then
212e11c3f44Smeem	set -- $ipmp_list
213e11c3f44Smeem	while [ $# -gt 0 ]; do
214e11c3f44Smeem	    	if /sbin/ifconfig $1 ipmp; then
215e11c3f44Smeem			ipmp_created="$ipmp_created $1"
216e11c3f44Smeem		else
217e11c3f44Smeem			ipmp_failed="$ipmp_failed $1"
218e11c3f44Smeem		fi
219e11c3f44Smeem		shift
220e11c3f44Smeem	done
221e11c3f44Smeem	[ -n "$ipmp_failed" ] && warn_failed_ifs "create IPv4 IPMP" \
222e11c3f44Smeem	    "$ipmp_failed"
223e11c3f44Smeemfi
2247c478bd9Sstevel@tonic-gate
2257c478bd9Sstevel@tonic-gate#
2267c478bd9Sstevel@tonic-gate# Step through the IPv4 interface list and try to plumb every interface.
2277c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv4 interfaces.
2287c478bd9Sstevel@tonic-gate#
2297c478bd9Sstevel@tonic-gateif [ -n "$inet_list" ]; then
2307c478bd9Sstevel@tonic-gate	set -- $inet_list
2317c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2327c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 plumb
2337c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet >/dev/null 2>&1; then
2347c478bd9Sstevel@tonic-gate			inet_plumbed="$inet_plumbed $1"
2357c478bd9Sstevel@tonic-gate		else
2367c478bd9Sstevel@tonic-gate			inet_failed="$inet_failed $1"
2377c478bd9Sstevel@tonic-gate		fi
2387c478bd9Sstevel@tonic-gate		shift
2397c478bd9Sstevel@tonic-gate	done
240e11c3f44Smeem	[ -n "$inet_failed" ] && warn_failed_ifs "plumb IPv4" "$inet_failed"
2417c478bd9Sstevel@tonic-gatefi
2427c478bd9Sstevel@tonic-gate
243516fc7f3Shx147065# Run autoconf to connect to a WLAN if the interface is a wireless one
244516fc7f3Shx147065if [ -x /sbin/wificonfig -a -n "$inet_plumbed" ]; then
245516fc7f3Shx147065	set -- $inet_plumbed
246516fc7f3Shx147065	while [ $# -gt 0 ]; do
247516fc7f3Shx147065			if [ -r /dev/wifi/$1 ]; then
248516fc7f3Shx147065				/sbin/wificonfig -i $1 startconf >/dev/null
249516fc7f3Shx147065			fi
250516fc7f3Shx147065		shift
251516fc7f3Shx147065	done
252516fc7f3Shx147065fi
253516fc7f3Shx147065
2547c478bd9Sstevel@tonic-gate#
2557c478bd9Sstevel@tonic-gate# Step through the IPv6 interface list and plumb every interface.
2567c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv6 interfaces.  Each plumbed
2577c478bd9Sstevel@tonic-gate# interface will be brought up later, after processing any contents of
2587c478bd9Sstevel@tonic-gate# the /etc/hostname6.* file.
2597c478bd9Sstevel@tonic-gate#
2607c478bd9Sstevel@tonic-gateif [ -n "$inet6_list" ]; then
2617c478bd9Sstevel@tonic-gate	set -- $inet6_list
2627c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2637c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 inet6 plumb
2647c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet6 >/dev/null 2>&1; then
2657c478bd9Sstevel@tonic-gate			inet6_plumbed="$inet6_plumbed $1"
2667c478bd9Sstevel@tonic-gate		else
2677c478bd9Sstevel@tonic-gate			inet6_failed="$inet6_failed $1"
2687c478bd9Sstevel@tonic-gate		fi
2697c478bd9Sstevel@tonic-gate		shift
2707c478bd9Sstevel@tonic-gate	done
271e11c3f44Smeem	[ -n "$inet6_failed" ] && warn_failed_ifs "plumb IPv6" "$inet6_failed"
272e11c3f44Smeemfi
273e11c3f44Smeem
274e11c3f44Smeem#
275e11c3f44Smeem# Create all of the IPv6 IPMP interfaces.
276e11c3f44Smeem#
277e11c3f44Smeemif [ -n "$ipmp6_list" ]; then
278e11c3f44Smeem	set -- $ipmp6_list
279e11c3f44Smeem	while [ $# -gt 0 ]; do
280e11c3f44Smeem	    	if /sbin/ifconfig $1 inet6 ipmp; then
281e11c3f44Smeem			ipmp6_created="$ipmp6_created $1"
282e11c3f44Smeem		else
283e11c3f44Smeem			ipmp6_failed="$ipmp6_failed $1"
284e11c3f44Smeem 		fi
285e11c3f44Smeem		shift
286e11c3f44Smeem	done
287e11c3f44Smeem	[ -n "$ipmp6_failed" ] && warn_failed_ifs "create IPv6 IPMP" \
288e11c3f44Smeem	    "$ipmp6_failed"
2897c478bd9Sstevel@tonic-gatefi
2907c478bd9Sstevel@tonic-gate
2910ba2cbe9Sxc151355#
292e11c3f44Smeem# Process the /etc/hostname[6].* files for IPMP interfaces.  Processing these
293e11c3f44Smeem# before non-IPMP interfaces avoids accidental implicit IPMP group creation.
2947c478bd9Sstevel@tonic-gate#
295e11c3f44Smeem[ -n "$ipmp_created" ] && if_configure inet "IPMP" $ipmp_created
296e11c3f44Smeem[ -n "$ipmp6_created" ] && if_configure inet6 "IPMP" $ipmp6_created
2977c478bd9Sstevel@tonic-gate
2987c478bd9Sstevel@tonic-gate#
299e11c3f44Smeem# Process the /etc/hostname[6].* files for non-IPMP interfaces.
3007c478bd9Sstevel@tonic-gate#
301e11c3f44Smeem[ -n "$inet_plumbed" ] && if_configure inet "" $inet_plumbed
302e11c3f44Smeem[ -n "$inet6_plumbed" ] && if_configure inet6 "" $inet6_plumbed
303e11c3f44Smeem
304e11c3f44Smeem#
305e11c3f44Smeem# For the IPv4 and IPv6 interfaces that failed to plumb, find (or create)
306e11c3f44Smeem# IPMP meta-interfaces to host their data addresses.
307e11c3f44Smeem#
308e11c3f44Smeem[ -n "$inet_failed" ] && move_addresses inet
309e11c3f44Smeem[ -n "$inet6_failed" ] && move_addresses inet6
3107c478bd9Sstevel@tonic-gate
3117c478bd9Sstevel@tonic-gate# Run DHCP if requested. Skip boot-configured interface.
3127c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/dhcp.*[0-9] 2>/dev/null`"
3137c478bd9Sstevel@tonic-gateif [ "$interface_names" != '/etc/dhcp.*[0-9]' ]; then
3147c478bd9Sstevel@tonic-gate	#
3157c478bd9Sstevel@tonic-gate	# First find the primary interface. Default to the first
3167c478bd9Sstevel@tonic-gate	# interface if not specified. First primary interface found
3177c478bd9Sstevel@tonic-gate	# "wins". Use care not to "reconfigure" a net-booted interface
3187c478bd9Sstevel@tonic-gate	# configured using DHCP. Run through the list of interfaces
3197c478bd9Sstevel@tonic-gate	# again, this time trying DHCP.
3207c478bd9Sstevel@tonic-gate	#
3217c478bd9Sstevel@tonic-gate	i4d_fail=
3227c478bd9Sstevel@tonic-gate	firstif=
3237c478bd9Sstevel@tonic-gate	primary=
3247c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
3257c478bd9Sstevel@tonic-gate	IFS="${IFS}."
3267c478bd9Sstevel@tonic-gate	set -- $interface_names
3277c478bd9Sstevel@tonic-gate
3287c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3297c478bd9Sstevel@tonic-gate		shift
3307c478bd9Sstevel@tonic-gate		[ -z "$firstif" ] && firstif=$1
3317c478bd9Sstevel@tonic-gate
3327c478bd9Sstevel@tonic-gate		for i in `shcat /etc/dhcp\.$1`; do
3337c478bd9Sstevel@tonic-gate			if [ "$i" = primary ]; then
3347c478bd9Sstevel@tonic-gate				primary=$1
3357c478bd9Sstevel@tonic-gate				break
3367c478bd9Sstevel@tonic-gate			fi
3377c478bd9Sstevel@tonic-gate		done
3387c478bd9Sstevel@tonic-gate
3397c478bd9Sstevel@tonic-gate		[ -n "$primary" ] && break
3407c478bd9Sstevel@tonic-gate		shift
3417c478bd9Sstevel@tonic-gate	done
3427c478bd9Sstevel@tonic-gate
3437c478bd9Sstevel@tonic-gate	[ -z "$primary" ] && primary="$firstif"
3447c478bd9Sstevel@tonic-gate	cmdline=`shcat /etc/dhcp\.${primary}`
3457c478bd9Sstevel@tonic-gate
3467c478bd9Sstevel@tonic-gate	if [ "$_INIT_NET_IF" != "$primary" ]; then
3477c478bd9Sstevel@tonic-gate		echo "starting DHCP on primary interface $primary"
3487c478bd9Sstevel@tonic-gate		/sbin/ifconfig $primary auto-dhcp primary $cmdline
3497c478bd9Sstevel@tonic-gate		# Exit code 4 means ifconfig timed out waiting for dhcpagent
3507c478bd9Sstevel@tonic-gate		[ $? != 0 ] && [ $? != 4 ] && i4d_fail="$i4d_fail $primary"
3517c478bd9Sstevel@tonic-gate	fi
3527c478bd9Sstevel@tonic-gate
3537c478bd9Sstevel@tonic-gate	set -- $interface_names
3547c478bd9Sstevel@tonic-gate
3557c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3567c478bd9Sstevel@tonic-gate		shift
3577c478bd9Sstevel@tonic-gate		cmdline=`shcat /etc/dhcp\.$1`
3587c478bd9Sstevel@tonic-gate		if [ "$1" != "$primary" -a \
3597c478bd9Sstevel@tonic-gate			"$1" != "$_INIT_NET_IF"  ]; then
3607c478bd9Sstevel@tonic-gate			echo "starting DHCP on interface $1"
3617c478bd9Sstevel@tonic-gate			/sbin/ifconfig $1 dhcp start wait 0 $cmdline
3627c478bd9Sstevel@tonic-gate			# Exit code can't be timeout when wait is 0
3637c478bd9Sstevel@tonic-gate			[ $? != 0 ] && i4d_fail="$i4d_fail $1"
3647c478bd9Sstevel@tonic-gate		fi
3657c478bd9Sstevel@tonic-gate		shift
3667c478bd9Sstevel@tonic-gate	done
3677c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
3687c478bd9Sstevel@tonic-gate	unset ORIGIFS
369e11c3f44Smeem	[ -n "$i4d_fail" ] && warn_failed_ifs "configure IPv4 DHCP" "$i4d_fail"
3707c478bd9Sstevel@tonic-gatefi
3717c478bd9Sstevel@tonic-gate
3720659b2b8Sse146197# In order to avoid bringing up the interfaces that have
3730659b2b8Sse146197# intentionally been left down, perform RARP only if the system
3740659b2b8Sse146197# has no configured hostname in /etc/nodename
3750659b2b8Sse146197hostname="`shcat /etc/nodename 2>/dev/null`"
3760659b2b8Sse146197if [ "$_INIT_NET_STRATEGY" = "rarp" -o -z "$hostname" ]; then
3777c478bd9Sstevel@tonic-gate	/sbin/ifconfig -adD4 auto-revarp netmask + broadcast + up
3780659b2b8Sse146197fi
3797c478bd9Sstevel@tonic-gate
3807c478bd9Sstevel@tonic-gate#
3817c478bd9Sstevel@tonic-gate# If the /etc/defaultrouter file exists, process it now so that the next
3827c478bd9Sstevel@tonic-gate# stage of booting will have access to NFS.
3837c478bd9Sstevel@tonic-gate#
3847c478bd9Sstevel@tonic-gateif [ -f /etc/defaultrouter ]; then
3857c478bd9Sstevel@tonic-gate	while read router rubbish; do
3867c478bd9Sstevel@tonic-gate		case "$router" in
3877c478bd9Sstevel@tonic-gate			'#'* | '') ;;	#  Ignore comments, empty lines
3887c478bd9Sstevel@tonic-gate			*)	/sbin/route -n add default -gateway $router ;;
3897c478bd9Sstevel@tonic-gate		esac
3907c478bd9Sstevel@tonic-gate	done </etc/defaultrouter
3917c478bd9Sstevel@tonic-gatefi
3927c478bd9Sstevel@tonic-gate
3937c478bd9Sstevel@tonic-gate#
394843e1988Sjohnlev# If we get here and were not asked to plumb any IPv4 interfaces, look
395843e1988Sjohnlev# for boot properties that direct us.
396843e1988Sjohnlev#
397843e1988Sjohnlev# - The "network-interface" property is required and indicates the
398843e1988Sjohnlev#   interface name.
399843e1988Sjohnlev# - The "xpv-hcp" property, if present, is used by the hypervisor
400843e1988Sjohnlev#   tools to indicate how the specified interface should be configured.
401843e1988Sjohnlev#   Permitted values are "dhcp" and "off", where "off" indicates static
402843e1988Sjohnlev#   IP configuration.
403843e1988Sjohnlev#
404843e1988Sjohnlev# In the case where "xpv-hcp" is set to "dhcp", no further properties
405843e1988Sjohnlev# are required or examined.
406843e1988Sjohnlev#
407843e1988Sjohnlev# In the case where "xpv-hcp" is not present or set to "off", the
408843e1988Sjohnlev# "host-ip" and "subnet-mask" properties are used to configure
409843e1988Sjohnlev# the specified interface.  The "router-ip" property, if present,
410843e1988Sjohnlev# is used to add a default route.
411843e1988Sjohnlev#
412843e1988Sjohnlevnic="`/sbin/devprop network-interface`"
413843e1988Sjohnlevif smf_is_globalzone && [ -z "$inet_list" ] && [ -n "$nic" ]; then
414843e1988Sjohnlev	hcp="`/sbin/devprop xpv-hcp`"
415843e1988Sjohnlev	case "$hcp" in
416843e1988Sjohnlev	"dhcp")
417843e1988Sjohnlev		/sbin/ifconfig $nic plumb 2>/dev/null
418843e1988Sjohnlev		[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
419843e1988Sjohnlev			# The interface is successfully plumbed, so
420843e1988Sjohnlev			# modify "inet_list" to force the exit code
421843e1988Sjohnlev			# checks to work.
422843e1988Sjohnlev			inet_list=$nic;
423843e1988Sjohnlev			# Given that this is the only IPv4 interface,
424843e1988Sjohnlev			# we assert that it is primary.
425843e1988Sjohnlev			echo "starting DHCP on primary interface $primary";
426843e1988Sjohnlev			/sbin/ifconfig $nic auto-dhcp primary;
427843e1988Sjohnlev			# Exit code 4 means ifconfig timed out waiting
428843e1988Sjohnlev			# for dhcpagent
429843e1988Sjohnlev			[ $? != 0 ] && [ $? != 4 ] && \
430843e1988Sjohnlev			    i4d_fail="$i4d_fail $nic";
431843e1988Sjohnlev		)
432843e1988Sjohnlev		;;
433843e1988Sjohnlev
434843e1988Sjohnlev	"off"|"")
435843e1988Sjohnlev		/sbin/devprop host-ip subnet-mask router-ip | (
436843e1988Sjohnlev			read ip;
437843e1988Sjohnlev			read mask;
438843e1988Sjohnlev			read router;
439843e1988Sjohnlev			[ -n "$ip" ] && [ -n "$mask" ] && \
440843e1988Sjohnlev				/sbin/ifconfig $nic plumb 2>/dev/null
441843e1988Sjohnlev			[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
442843e1988Sjohnlev				# The interface is successfully
443843e1988Sjohnlev				# plumbed, so modify "inet_list" to
444843e1988Sjohnlev				# force the exit code checks to work.
445843e1988Sjohnlev				inet_list=$nic;
446843e1988Sjohnlev				/sbin/ifconfig $nic  inet $ip \
447843e1988Sjohnlev				    netmask $mask broadcast + up 2>/dev/null;
448843e1988Sjohnlev				[ -n "$router" ] && route add \
449843e1988Sjohnlev				    default $router 2>/dev/null;
450843e1988Sjohnlev			)
451843e1988Sjohnlev		)
452843e1988Sjohnlev		;;
453843e1988Sjohnlev	esac
454843e1988Sjohnlevfi
455843e1988Sjohnlev
456843e1988Sjohnlev#
4577c478bd9Sstevel@tonic-gate# We tell smf this service is online if any of the following is true:
4587c478bd9Sstevel@tonic-gate# - no interfaces were configured for plumbing and no DHCP failures
4597c478bd9Sstevel@tonic-gate# - any non-loopback IPv4 interfaces are up and have a non-zero address
4607c478bd9Sstevel@tonic-gate# - there are any DHCP interfaces started
4617c478bd9Sstevel@tonic-gate# - any non-loopback IPv6 interfaces are up
4627c478bd9Sstevel@tonic-gate#
4637c478bd9Sstevel@tonic-gate# If we weren't asked to configure any interfaces, exit
4647c478bd9Sstevel@tonic-gateif [ -z "$inet_list" ] && [ -z "$inet6_list" ]; then
4657c478bd9Sstevel@tonic-gate	# Config error if DHCP was attempted without plumbed interfaces
4667c478bd9Sstevel@tonic-gate	[ -n "$i4d_fail" ] && exit $SMF_EXIT_ERR_CONFIG
4677c478bd9Sstevel@tonic-gate	exit $SMF_EXIT_OK
4687c478bd9Sstevel@tonic-gatefi
4697c478bd9Sstevel@tonic-gate
4707c478bd9Sstevel@tonic-gate# Any non-loopback IPv4 interfaces with usable addresses up?
4717c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -a4u`" ]; then
4727c478bd9Sstevel@tonic-gate    	/sbin/ifconfig -a4u | while read intf addr rest; do
4737c478bd9Sstevel@tonic-gate		[ $intf = inet ] && [ $addr != 127.0.0.1 ] &&
474843e1988Sjohnlev		[ $addr != 0.0.0.0 ] && exit $SMF_EXIT_OK
4757c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4767c478bd9Sstevel@tonic-gatefi
4777c478bd9Sstevel@tonic-gate
4787c478bd9Sstevel@tonic-gate# Any DHCP interfaces started?
4797c478bd9Sstevel@tonic-gate[ -n "`/sbin/ifconfig -a4 dhcp status 2>/dev/null`" ] && exit $SMF_EXIT_OK
4807c478bd9Sstevel@tonic-gate
4817c478bd9Sstevel@tonic-gate# Any non-loopback IPv6 interfaces up?
4827c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -au6`" ]; then
4837c478bd9Sstevel@tonic-gate	/sbin/ifconfig -au6 | while read intf addr rest; do
484843e1988Sjohnlev		[ $intf = inet6 ] && [ $addr != ::1/128 ] && exit $SMF_EXIT_OK
4857c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4867c478bd9Sstevel@tonic-gatefi
4877c478bd9Sstevel@tonic-gate
4887c478bd9Sstevel@tonic-gate# This service was supposed to configure something yet didn't.  Exit
4897c478bd9Sstevel@tonic-gate# with config error.
4907c478bd9Sstevel@tonic-gateexit $SMF_EXIT_ERR_CONFIG
491